// clicky.cpp : Implementierung von WinMain


#include "stdafx.h"
#include "resource.h"
#include "clicky.h"

#define TEXTBUF_SIZE 32768
// #define LOG(T) Log(_T(T), sizeof(_T(T)))
#define LOG(T)

// clicky32

typedef void (CALLBACK * GetLogPath_t)(DWORD, TCHAR *);
typedef void (CALLBACK * Log_t)(const TCHAR *, size_t);
typedef LRESULT (CALLBACK * GetMsgProc_t)(int, WPARAM, LPARAM);

GetLogPath_t GetLogPath;
Log_t Log;
GetMsgProc_t GetMsgProc;

class CclickyModule : public CAtlExeModuleT< CclickyModule >
{
public :
	DECLARE_LIBID(LIBID_clickyLib)
	DECLARE_REGISTRY_APPID_RESOURCEID(IDR_CLICKY, "{BECC988B-71A1-4583-977C-B850E0E06CEE}")

	HRESULT PreMessageLoop(int nShowCmd) throw();
	HINSTANCE getInstance() const { return m_hInstance; }

private:
	HINSTANCE m_hInstance;
	HHOOK m_hHook;
	HWND m_hWnd;
	HWND m_hDlg;
	TCHAR m_pLogPath[TEXTBUF_SIZE];
};

CclickyModule _AtlModule;

HRESULT CclickyModule::PreMessageLoop(int nShowCmd) {
	CAtlExeModuleT< CclickyModule >::PreMessageLoop(nShowCmd);

	m_hInstance = LoadLibrary(_T("clicky32.dll"));
	if (m_hInstance == NULL) {
		MessageBox(NULL, _T("Cannot load clicky32.dll."), _T("Error loading clicky"), MB_OK | MB_ICONSTOP);
		return E_ABORT;
	}

	GetLogPath = (GetLogPath_t) GetProcAddress(m_hInstance, "GetLogPath");
	Log = (Log_t) GetProcAddress(m_hInstance, "Log");
	GetMsgProc = (GetMsgProc_t) GetProcAddress(m_hInstance, "GetMsgProc");

	Log(_T("\r\n"), sizeof(_T("\r\n")));

	do {
		// wait until it's open
		Sleep(200);
//		m_hWnd = FindWindowEx(NULL, NULL, _T("SunAwtFrame"), _T("Identittsnachweis  PIN-Eingabe"));
		m_hWnd = FindWindowEx(NULL, NULL, _T("Notepad"), NULL);
		if (m_hWnd)
			m_hWnd = FindWindowEx(m_hWnd, NULL, _T("Edit"), NULL);
	} while (m_hWnd == NULL);
	LOG("* Window found.\n");

	m_hHook = SetWindowsHookEx(WH_GETMESSAGE, GetMsgProc, getInstance(), NULL);
	if (m_hHook != NULL)
		LOG("* Hook set.\n");
	else
		LOG("* Error: Hook cannot be set.\n");

	do {
		Sleep(200);
//		m_hWnd = FindWindowEx(NULL, NULL, _T("SunAwtFrame"), _T("Identittsnachweis  PIN-Eingabe"));
		m_hWnd = FindWindowEx(NULL, NULL, _T("Notepad"), NULL);
		// wait until it's closed again
	} while (m_hWnd != NULL);
	LOG("\n* Window away.\n");

	UnhookWindowsHookEx(m_hHook);
	LOG("* Hook released.\n");

	PostQuitMessage(0);
	return S_OK;
}

//
extern "C" int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, 
                                LPTSTR /*lpCmdLine*/, int nShowCmd)
{
    return _AtlModule.WinMain(nShowCmd);
}
