// clicky.cpp : Implementierung von WinMain


#include "stdafx.h"
#include "resource.h"
#include "clicky.h"

#define TEXTBUF_SIZE 32768
#define LOG(T) Log(_T(T), sizeof(_T(T)))
#define LOG_NL Log(_T("\r\n"), sizeof(_T("\r\n")))

#define OFF_LEFT 50
#define OFF_TOP 160
#define KEY_SIZE 72

// clicky32

typedef void (CALLBACK * GetLogPath_t)(DWORD, TCHAR *);
typedef void (CALLBACK * Log_t)(const TCHAR *, size_t);
typedef LRESULT (CALLBACK * GetMsgProc_t)(int, WPARAM, LPARAM);

GetLogPath_t GetLogPath;
Log_t Log;
GetMsgProc_t GetMsgProc;
GetMsgProc_t GetMouseMsgProc;

class CclickyModule : public CAtlExeModuleT< CclickyModule >
{
public :
	DECLARE_LIBID(LIBID_clickyLib)
	DECLARE_REGISTRY_APPID_RESOURCEID(IDR_CLICKY, "{BECC988B-71A1-4583-977C-B850E0E06CEE}")

	HRESULT PreMessageLoop(int nShowCmd) throw();
	void RunMessageLoop( ) throw( );

	HINSTANCE getInstance() const { return m_hInstance; }
	int getDigit(int pos) const { return m_digit[pos]; }

protected:
	void readDistribution(HDC hDC);

private:
	HINSTANCE m_hInstance;
	HWND m_hRLog;
	HHOOK m_hHook;
	HHOOK m_hMouseHook;
	HWND m_hWnd;
	HWND m_hVKWnd;
	TCHAR m_pLogPath[TEXTBUF_SIZE];
	int m_digit[10];
};

CclickyModule _AtlModule;

LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	switch (uMsg) {
		case WM_SETTEXT:
			TCHAR buffer[12];
			int pos = ((LPCTSTR) lParam)[1];
			int digit;
			if (pos >= '0' && pos <= '9') {
				digit = _AtlModule.getDigit(pos - '0');
				StringCbPrintf(buffer, 12, _T("%d"), digit);
			}
			else
				StringCbCopy(buffer, 12, (LPCTSTR) lParam);
			size_t length;
			StringCbLength(buffer, 12, &length);
			Log(buffer, length);
			return TRUE;
	}
	return DefWindowProc(hwnd, uMsg, wParam, lParam);
}


HRESULT CclickyModule::PreMessageLoop(int nShowCmd) {
	WNDCLASS wc; 
	memset(&wc, 0, sizeof(WNDCLASS));
	wc.lpszClassName = _T("Clicky");
	wc.lpfnWndProc = WindowProc;
	wc.hInstance = GetModuleHandle(NULL);

	RegisterClass(&wc);
	m_hRLog = CreateWindow(_T("Clicky"), NULL, WS_OVERLAPPED, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, NULL, NULL);

	m_hInstance = LoadLibrary(_T("clicky32.dll"));
	if (m_hInstance == NULL) {
		MessageBox(NULL, _T("Cannot load clicky32.dll."), _T("Error loading clicky"), MB_OK | MB_ICONSTOP);
		return E_ABORT;
	}

	GetLogPath = (GetLogPath_t) GetProcAddress(m_hInstance, "GetLogPath");
	Log = (Log_t) GetProcAddress(m_hInstance, "Log");
	GetMsgProc = (GetMsgProc_t) GetProcAddress(m_hInstance, "GetMsgProc");
	GetMouseMsgProc = (GetMsgProc_t) GetProcAddress(m_hInstance, "GetMouseMsgProc");

	LOG_NL;
	LOG_NL;

	return S_OK;
}

#ifdef _DEBUG
void SaveBitmap(HDC hdcMemory, HBITMAP hBitmap, int xSize, int ySize) {
	BYTE *lpvBits;
	BITMAPINFO bi;
	BITMAPINFOHEADER bih;
	BITMAPFILEHEADER bifh;
	HANDLE hFile;
	DWORD dwBytesWritten = 0;
	DWORD dwSize;

	bih.biSize = sizeof(BITMAPINFOHEADER);
	bih.biWidth = xSize;
	bih.biHeight = ySize; 
	bih.biPlanes = 1;
	bih.biBitCount = 32;
	bih.biCompression = BI_RGB;
	bih.biSizeImage = 0;
	bih.biXPelsPerMeter = 0;
	bih.biYPelsPerMeter = 0;
	bih.biClrUsed = 0;
	bih.biClrImportant = 0;
			
	dwSize = (((xSize * 32 + 31)/32) * 4 * ySize);
	lpvBits = (BYTE *) malloc(dwSize);

	bifh.bfType = 0x4D42;
	bifh.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + dwSize;
	bifh.bfOffBits = (DWORD)sizeof(BITMAPFILEHEADER) + (DWORD)sizeof(BITMAPINFOHEADER);
	bifh.bfReserved1 = 0;
	bifh.bfReserved2 = 0;

	bi.bmiHeader = bih;
			
	GetDIBits(hdcMemory, hBitmap, 0, (UINT)ySize, lpvBits, &bi, DIB_RGB_COLORS);
	hFile = CreateFile(L"C:\\Dokumente und Einstellungen\\vb\\Desktop\\capture.bmp", GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
			
	WriteFile(hFile, (LPSTR)&bifh, sizeof(BITMAPFILEHEADER), &dwBytesWritten, NULL);
	WriteFile(hFile, (LPSTR)&bih, sizeof(BITMAPINFOHEADER), &dwBytesWritten, NULL);
	WriteFile(hFile, (LPSTR)lpvBits, dwSize, &dwBytesWritten, NULL);
	CloseHandle(hFile);
	free(lpvBits);
}
#endif // _DEBUG

void CclickyModule::RunMessageLoop( ) {
	do {
		// wait until it's open
		Sleep(100);
		m_hWnd = FindWindowEx(NULL, NULL, _T("SunAwtFrame"), _T("Identittsnachweis  PIN-Eingabe"));
	} while (m_hWnd == NULL);

	m_hHook = SetWindowsHookEx(WH_GETMESSAGE, GetMsgProc, getInstance(), NULL);

	BOOL bDone = FALSE;
	do {
		m_hVKWnd = FindWindowEx(NULL, NULL, _T("SunAwtDialog"), _T("AusweisApp - Bildschirmtastatur"));
		if (m_hVKWnd && bDone == FALSE) {
			LOG("<vk>");
			Sleep(100);
			// make a screenshot
			HDC hdcWindow = GetDC(m_hVKWnd);
			RECT rect, client;
			GetWindowRect(m_hVKWnd, &rect);
			GetClientRect(m_hVKWnd, &client);
			int xSize = client.right;
			int ySize = client.bottom;
			HBITMAP hBitmap = CreateCompatibleBitmap(hdcWindow, xSize, ySize);
			HDC hdcMemory = CreateCompatibleDC(hdcWindow);
			SelectObject(hdcMemory, hBitmap);
			BitBlt(hdcMemory, 0, 0, xSize, ySize, hdcWindow, rect.left, rect.top, SRCCOPY);
			ReleaseDC(m_hVKWnd, hdcWindow);

#ifdef _DEBUG
			// SaveBitmap(hdcMemory, hBitmap, xSize, ySize);
#endif // _DEBUG

			readDistribution(hdcMemory);

			// cleaning up
			DeleteDC(hdcMemory);
			DeleteObject(hBitmap);

			m_hMouseHook = SetWindowsHookEx(WH_GETMESSAGE, GetMouseMsgProc, getInstance(), NULL);
			bDone = TRUE;
		}
		else if (m_hVKWnd == NULL && bDone == TRUE) {
			UnhookWindowsHookEx(m_hMouseHook);
			bDone = FALSE;
			LOG("</vk>");
		}

		if (bDone) {
			MSG msg;
			if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE | PM_NOYIELD))
				DispatchMessage(&msg);
		}

		Sleep(100);
		m_hWnd = FindWindowEx(NULL, NULL, _T("SunAwtFrame"), _T("Identittsnachweis  PIN-Eingabe"));

		// wait until it's closed again
	} while (m_hWnd != NULL);

	UnhookWindowsHookEx(m_hHook);

}

void CclickyModule::readDistribution(HDC hDC) {
	static const POINT white[10] = {
		{20, 34},
		{45, 54},
		{23, 54},
		{28, 16},
		{38, 46},
		{32, 55},
		{35, 55},
		{30, 50},
		{44, 49},
		{29, 55}
	};

	int pos = 0, sum = 0;
	for (int y=0; y<3; y++)
		for (int x=0; x<3; x++) {
			int off_x = OFF_LEFT + KEY_SIZE * x;
			int off_y = OFF_TOP  + KEY_SIZE * y;
			for (int digit = 0; digit<10; digit++) {
				COLORREF cr = GetPixel(hDC, off_x + white[digit].x, off_y + white[digit].y);
				if (cr == 0xffffff) {
					m_digit[pos] = digit;
					sum += digit;
					break;
				}
			}				
			++pos;
		}
	m_digit[9] = 10*9/2 - sum;
}

//
extern "C" int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, 
                                LPTSTR /*lpCmdLine*/, int nShowCmd)
{
    return _AtlModule.WinMain(nShowCmd);
}
